com.fasterxml.jackson.databind.jsontype.impl

## Class AsExternalTypeSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.TypeSerializer
  - - com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase
    - - com.fasterxml.jackson.databind.jsontype.impl.AsExternalTypeSerializer

    public class AsExternalTypeSerializer
    extends TypeSerializerBase

Type serializer that preferably embeds type information as an "external" type property; embedded in enclosing JSON object. Note that this serializer should only be used when value is being output at JSON Object context; otherwise it cannot work reliably, and will have to revert operation similar to `AsPropertyTypeSerializer`.

Note that implementation of serialization is bit cumbersome as we must serialized external type id AFTER object; this because callback only occurs after field name has been written.

Also note that this type of type id inclusion will NOT try to make use of native Type Ids, even if those exist.

### Field Summary

Fields
`protected String` `_typePropertyName`

### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

`_idResolver, _property`

### Constructor Summary

Constructors
Constructor and Description
`AsExternalTypeSerializer(TypeIdResolver idRes, BeanProperty property, String propName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `_writeArrayPrefix(Object value, JsonGenerator g)`
`protected void` `_writeArraySuffix(Object value, JsonGenerator g, String typeId)`
`protected void` `_writeObjectPrefix(Object value, JsonGenerator g)`
`protected void` `_writeObjectSuffix(Object value, JsonGenerator g, String typeId)`
`protected void` `_writeScalarPrefix(Object value, JsonGenerator g)`
`protected void` `_writeScalarSuffix(Object value, JsonGenerator g, String typeId)`
`AsExternalTypeSerializer` `forProperty(BeanProperty prop)` Method called to create contextual version, to be used for values of given property.
`String` `getPropertyName()` Name of property that contains type information, if property-based inclusion is used.
`JsonTypeInfo.As` `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.

### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

`_generateTypeId, getTypeIdResolver, handleMissingId, idFromValue, idFromValueAndType, writeTypePrefix, writeTypeSuffix`

### Methods inherited from class com.fasterxml.jackson.databind.jsontype.TypeSerializer

`_writeLegacySuffix, typeId, typeId, typeId, writeCustomTypePrefixForArray, writeCustomTypePrefixForObject, writeCustomTypePrefixForScalar, writeCustomTypeSuffixForArray, writeCustomTypeSuffixForObject, writeCustomTypeSuffixForScalar, writeTypePrefixForArray, writeTypePrefixForArray, writeTypePrefixForObject, writeTypePrefixForObject, writeTypePrefixForScalar, writeTypePrefixForScalar, writeTypeSuffixForArray, writeTypeSuffixForObject, writeTypeSuffixForScalar`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _typePropertyName

    protected final String _typePropertyName

### Constructor Detail

#### AsExternalTypeSerializer

    public AsExternalTypeSerializer(TypeIdResolver idRes,
                                    BeanProperty property,
                                    String propName)

### Method Detail

#### forProperty

    public AsExternalTypeSerializer forProperty(BeanProperty prop)

Description copied from class: `TypeSerializer`
Method called to create contextual version, to be used for values of given property. This may be the type itself (as is the case for bean properties), or values contained (for `Collection` or `Map` valued properties).

Specified by:
  `forProperty` in class `TypeSerializer`

#### getPropertyName

    public String getPropertyName()

Description copied from class: `TypeSerializer`
Name of property that contains type information, if property-based inclusion is used.

Overrides:
  `getPropertyName` in class `TypeSerializerBase`

#### getTypeInclusion

    public JsonTypeInfo.As getTypeInclusion()

Description copied from class: `TypeSerializer`
Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.

Specified by:
  `getTypeInclusion` in class `TypeSerializerBase`

#### _writeScalarPrefix

    protected final void _writeScalarPrefix(Object value,
                                            JsonGenerator g)
                                     throws IOException

Throws:
  `IOException`

#### _writeObjectPrefix

    protected final void _writeObjectPrefix(Object value,
                                            JsonGenerator g)
                                     throws IOException

Throws:
  `IOException`

#### _writeArrayPrefix

    protected final void _writeArrayPrefix(Object value,
                                           JsonGenerator g)
                                    throws IOException

Throws:
  `IOException`

#### _writeScalarSuffix

    protected final void _writeScalarSuffix(Object value,
                                            JsonGenerator g,
                                            String typeId)
                                     throws IOException

Throws:
  `IOException`

#### _writeObjectSuffix

    protected final void _writeObjectSuffix(Object value,
                                            JsonGenerator g,
                                            String typeId)
                                     throws IOException

Throws:
  `IOException`

#### _writeArraySuffix

    protected final void _writeArraySuffix(Object value,
                                           JsonGenerator g,
                                           String typeId)
                                    throws IOException

Throws:
  `IOException`